<?php
/*
Plugin Name:  WPAutoRankerPro
Plugin URI: http://wpautoranker.com
Description: Auto Ranker Pro.
Version: 0.8.5
Author: Dan Green
*/

ini_set('display_errors', '0');     # don't show any errors...
require_once(ABSPATH . 'wp-includes/pluggable.php');

require_once 'class.arfeedly.php';
require_once 'class.arfeeds.php';
require_once 'class.arpixabay.php';
require_once 'class.arimages.php';
require_once 'class.arcampaigns.php';
require_once 'class.arprotected.php';
require_once 'class.arsynonyms.php';
require_once 'ar_install.php';
require_once 'ar_admin.php';
require_once 'ar_campaigns.php';
require_once 'ar_settings.php';
require_once 'ar_contents.php';
require_once 'ar_images.php';
require_once 'ar_protected_words.php';
require_once 'plugin_update_check.php';

$MyUpdateChecker = new PluginUpdateChecker_2_0(
    'https://kernl.us/api/v1/updates/5c6a7d03d138c37ff2f0a1d2/',
    __FILE__,
    'wpautorankerpro',
    1
);

$LOGO = plugin_dir_url(__FILE__) . '/assets/logo-400.png';
$FAVICON = plugin_dir_url(__FILE__) . 'favicon.png';

define("WPAUTORANKER", "<img src='" . $LOGO . "' />");

add_action('admin_menu', 'ar_menu');
register_activation_hook(__FILE__, 'ar_install');
add_action('admin_enqueue_scripts', 'ar_admin_scripts');

function ar_header($title) {
  echo '
  <div class="wrap">
    <div class="">' . WPAUTORANKER . '</div>
    <h1>' . $title . '</h1>
    <hr />
  ';
}

function ar_support() {
  ar_header('Support');

  echo '
    <iframe src="http://wpautoranker.com/support.html" width="100%" height="3500px" scrolling="no"></iframe>
  </div>
  ';
}

function ar_menu() {
    $hook = add_menu_page('WPAutoRanker', __('WPAutoRanker', 'ar'), 'manage_options', 'ar', 'ar_admin', $FAVICON);
    $campaigns = add_submenu_page('ar', 'Settings', 'General Settings', 'manage_options', 'ar', 'ar_admin');
    $campaigns = add_submenu_page('ar', 'Campaigns', 'Campaigns', 'manage_options', 'ar_campaigns', 'ar_campaigns');
    $support = add_submenu_page('ar', 'Support', 'Support', 'manage_options', 'ar_support', 'ar_support');
}

function ar_admin_scripts() {
    wp_enqueue_style('ar-admin-css', plugins_url('assets/css/admin-style.css', __FILE__), false);
    wp_enqueue_style('ar-photoswipe-css', plugins_url('assets/photoswipe/photoswipe.css', __FILE__), false);
    wp_enqueue_style('ar-photoswipe-skin-css', plugins_url('assets/photoswipe/default-skin/default-skin.css', __FILE__), false);
    wp_enqueue_style('ar-toggleswitch-css', plugins_url('assets/toggleswitch/tinytools.toggleswitch.min.css', __FILE__), false);
    wp_enqueue_script('jquery');
    wp_enqueue_script('ar-photoswipe-js', plugins_url('assets/photoswipe/photoswipe.min.js', __FILE__), false);
    wp_enqueue_script('ar-photoswipe-skin-js', plugins_url('assets/photoswipe/photoswipe-ui-default.min.js', __FILE__), false);
    wp_enqueue_script('ar-toggleswitch-js', plugins_url('assets/toggleswitch/tinytools.toggleswitch.min.js', __FILE__), false);
    wp_enqueue_script('ar-admin-js', plugins_url('assets/js/main.js', __FILE__), false);
}

function ar_add_custom_box()
{
    $screens = ['post'];
    foreach ($screens as $screen) {
        add_meta_box(
            'word_ai_spun',
            'WordAI Spun',
            'ar_custom_box_html',
            $screen,
            'side'
        );
    }
}
add_action('add_meta_boxes', 'ar_add_custom_box');

function ar_custom_box_html($post)
{
    ?>
    <div class="components-base-control__field">
      <input id="ar_wordai_spun" name="ar_wordai_spun" class="components-checkbox-control__input" type="checkbox" value="1">
      <label class="components-checkbox-control__label" for="ar_wordai_spun">Process/Spun Content with WordAI</label>
    </div>
    <?php
}

add_filter('wp_insert_post_data' , 'ar_filter_post_data' , '99', 2);
function ar_filter_post_data($data , $postarr) {
    if (array_key_exists('ar_wordai_spun', $_POST)) {
      $spun_spintax = ar_wordai_api($data['post_content'], $postarr['ID']);
      $spintax = new arSpintax();
      $content = $spintax->process($spun_spintax);
      $data['post_content'] = $content;
    }

    return $data;
}

function ar_photoswipe_dom() {
    echo '<div class="pswp" tabindex="-1" role="dialog" aria-hidden="true">
    <div class="pswp__bg"></div>
    <div class="pswp__scroll-wrap">
        <div class="pswp__container">
            <div class="pswp__item"></div>
            <div class="pswp__item"></div>
            <div class="pswp__item"></div>
        </div>
        <div class="pswp__ui pswp__ui--hidden">
            <div class="pswp__top-bar">
                <div class="pswp__counter"></div>
                <button class="pswp__button pswp__button--close" title="Close (Esc)"></button>
                <button class="pswp__button pswp__button--share" title="Share"></button>
                <button class="pswp__button pswp__button--fs" title="Toggle fullscreen"></button>
                <button class="pswp__button pswp__button--zoom" title="Zoom in/out"></button>
                <div class="pswp__preloader">
                    <div class="pswp__preloader__icn">
                      <div class="pswp__preloader__cut">
                        <div class="pswp__preloader__donut"></div>
                      </div>
                    </div>
                </div>
            </div>
            <div class="pswp__share-modal pswp__share-modal--hidden pswp__single-tap">
                <div class="pswp__share-tooltip"></div>
            </div>
            <button class="pswp__button pswp__button--arrow--left" title="Previous (arrow left)">
            </button>
            <button class="pswp__button pswp__button--arrow--right" title="Next (arrow right)">
            </button>
            <div class="pswp__caption">
                <div class="pswp__caption__center"></div>
            </div>
        </div>
    </div>
</div>';
}
add_action( 'admin_footer', 'ar_photoswipe_dom' );

function ar_get_protected_words() {
  global $wpdb;
  $table_name = $wpdb->prefix . "arp_protected";
  $query = "SELECT * FROM $table_name";
  $data = $wpdb->get_results($query, "ARRAY_A");

  $outa = [];
  foreach ($data as $row) {
    array_push($outa, $row['protected']);
  }

  return implode(',', $outa);
}

function ar_get_synonyms() {
  global $wpdb;
  $table_name = $wpdb->prefix . "arp_synonyms";
  $query = "SELECT * FROM $table_name";
  $data = $wpdb->get_results($query, "ARRAY_A");

  $outa = [];
  foreach ($data as $row) {
    array_push($outa, $row['synonyms']);
  }

  return implode(',', $outa);
}

function ar_wordai_api($text, $campaignId) {
  // $email = get_post_meta('111111119', 'ar_wordai_email', true);
  // $hash = get_post_meta('111111119', 'ar_wordai_hash', true);

  $email = "1337dang@gmail.com";
  $hash = "769bb0a91a0f221a089140c2dd48b26f";

  $ar_wordai_quality      = get_post_meta('111111119', $campaignId . 'ar_wordai_quality', true);
  $ar_wordai_title        = get_post_meta('111111119', $campaignId . 'ar_wordai_title', true);
  $ar_wordai_sentence     = get_post_meta('111111119', $campaignId . 'ar_wordai_sentence', true);
  $ar_wordai_paragraph    = get_post_meta('111111119', $campaignId . 'ar_wordai_paragraph', true);
  $ar_wordai_nooriginal   = get_post_meta('111111119', $campaignId . 'ar_wordai_nooriginal', true);
  // $ar_wordai_usage        = intval(get_post_meta('111111119', $campaignId . "ar_wordai_usage_" . date('Ymd'), true));

  $synonyms = ar_get_synonyms();
  $protected = ar_get_protected_words();

  if (isset($text)) {
    // if ($ar_wordai_usage + str_word_count($text) >= 1000) {
    //   return $text;
    // } else {
    // update_post_meta('111111119', "ar_wordai_usage_" . date('Ymd'), $ar_wordai_usage + str_word_count($text));
    // }

    $text = urlencode($text);
    $ch = curl_init('http://wordai.com/users/turing-api.php');

    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt ($ch, CURLOPT_POST, 1);

    $params = "s=$text&quality=$ar_wordai_quality&email=$email&hash=$hash&output=json";
    if ($ar_wordai_title == 'yes') { $params .= "&title=on"; }
    if ($ar_wordai_sentence == 'yes') { $params .= "&sentence=on"; }
    if ($ar_wordai_paragraph == 'yes') { $params .= "&paragraph=on"; }
    if ($ar_wordai_nooriginal == 'yes') { $params .= "&nooriginal=on"; }
    if (!empty($synonyms)) { $params .= "&synonyms=" . $synonyms; }
    if (!empty($protected)) { $params .= "&protected=" . $protected; }

    curl_setopt ($ch, CURLOPT_POSTFIELDS, $params);

    $result = curl_exec($ch);
    curl_close ($ch);

    $result = json_decode(trim($result));
    if ($result->status == 'Success') return $result->text;
    return null;
  } else {
    return null;
  }
}

// search pixabay free images by keyword
function ar_pixabay_api($keyword, $campaignId) {
  $hash = get_post_meta('111111119', $campaignId . 'ar_pixabay_hash', true);

  if (isset($keyword)) {
    $text = urlencode($keyword);
    $ch = curl_init("https://pixabay.com/api/?key=$hash&q=$text&image_type=couple&per_page=200");

    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    $result = curl_exec($ch);
    curl_close ($ch);
    $result = json_decode(trim($result), true);

    return $result['hits'];
    return null;
  } else {
    return null;
  }
}

/* this method is used from WP_List_Tables */
function ar_usort_reorder($a, $b) {
  $orderby = (!empty($_REQUEST['orderby'])) ? $_REQUEST['orderby'] : 'subscribers'; // If no sort, default to title
  $order = (!empty($_REQUEST['order'])) ? $_REQUEST['order'] : 'desc'; // If no order, default to asc

  if ($orderby === 'subscribers') {
    $aa = intval(str_replace([',', '.', ''], '', $a[$orderby]));
    $bb = intval(str_replace([',', '.', ''], '', $b[$orderby]));
    $result = ($aa === $bb) ? 0 : ($aa > $bb) ? 1 : -1;
  } else {
    $result = strcmp($a[$orderby], $b[$orderby]); //Determine sort order
  }
  return ($order === 'asc') ? $result : -$result; //Send final sort direction to usort
}


/* this method is used from WP_List_Tables */
function ar_pusort_reorder($a, $b) {
  $orderby = (!empty($_REQUEST['orderby'])) ? $_REQUEST['orderby'] : 'downloads'; // If no sort, default to title
  $order = (!empty($_REQUEST['order'])) ? $_REQUEST['order'] : 'desc'; // If no order, default to asc

  if ($orderby === 'downloads' || $orderby === 'favorites' || $orderby === 'views') {
    $aa = intval(str_replace([',', '.', ''], '', $a[$orderby]));
    $bb = intval(str_replace([',', '.', ''], '', $b[$orderby]));
    $result = ($aa === $bb) ? 0 : ($aa > $bb) ? 1 : -1;
  } else {
    $result = strcmp($a[$orderby], $b[$orderby]); //Determine sort order
  }
  return ($order === 'asc') ? $result : -$result; //Send final sort direction to usort
}

class arSpintax
{
  public function process($text)
  {
    return preg_replace_callback('/\{(((?>[^\{\}]+)|(?R))*)\}/x', array($this, 'replace'), $text);
  }

  public function replace($text)
  {
    $text = $this->process($text[1]);
    $parts = explode('|', $text);
    return $parts[array_rand($parts)];
  }
}

function ar_get_image_details($item) {
  if (!empty($item['imageURL'])) {
    $image = $item['imageURL'];
    $imageWidth = $item['imageWidth'];
    $imageHeight = $item['imageHeight'];
  } else if (!empty($item['fullHDURL'])) {
    $image = $item['fullHDURL'];
    $imageWidth = 1920;
    $imageHeight = $item['imageHeight'] * $imageWidth / $item['imageWidth'];
  } else if (!empty($item['largeImageURL'])) {
    $image = $item['largeImageURL'];
    $imageWidth = 1280;
    $imageHeight = $item['imageHeight'] * $imageWidth / $item['imageWidth'];
  } else {
    $image = $item['previewURL'];
    $imageWidth = $item['webformatWidth'];
    $imageHeight = $item['webformatHeight'];
  }

  return [$image, $imageWidth, $imageHeight];
}

function ar_download_image($url) {
  $ch = curl_init($url);
  $filename = 'temp/' . uniqid();

  $path = plugin_dir_path(__FILE__ ) . $filename;
  $url = plugin_dir_url(__FILE__ ) . $filename;

  $fp = fopen($path, 'wb');
  curl_setopt($ch, CURLOPT_FILE, $fp);
  curl_setopt($ch, CURLOPT_HEADER, 0);
  curl_exec($ch);
  curl_close($ch);
  fclose($fp);

  return $url;
}
